Index: /trunk/src/sh_database.c
===================================================================
--- /trunk/src/sh_database.c	(revision 584)
+++ /trunk/src/sh_database.c	(revision 1)
@@ -1430,5 +1328,5 @@
 	      (void)
 	      md5Update(&crc,
-			(sh_byte *) db_entry->ulong_data[attr_tab[i].val-START_SEC_LONGS], 
+			(sh_byte *) db_entry->long_data[attr_tab[i].val-START_SEC_LONGS], 
 			sizeof(long));
 	      /*@+type@*/
@@ -1463,5 +1361,5 @@
 		      db_table, columns, values);
 
-  sh_database_query (query, &the_id);
+  status = sh_database_query (query, &the_id);
 
   /*@-usedef@*//* no, 'values' is allocated here */
@@ -1473,66 +1371,45 @@
 }
  
-static int sh_database_comp_attr (const void *m1, const void *m2) 
-{
-  const my_attr *mi1 = (const my_attr *) m1;
-  const my_attr *mi2 = (const my_attr *) m2;
-  return strcmp(mi1->attr, mi2->attr);
-}
-
-
-static void init_attr_table(void)
+
+static void init_attr_table()
 {
   static  int first = S_TRUE;
-  int         i, j;
+  int         i;
 
 #ifdef SH_STEALTH
-  int     k;
-
-  if (first == S_FALSE)
-    return;
-
-  i = 0;
-  while (attr_tab[i].attr_o != NULL)
-    {
-      j = strlen(attr_tab[i].attr_o);
-      attr_tab[i].attr = calloc(1, j+1); /* only once */
-      if (NULL == attr_tab[i].attr)
-	return;
-      for (k = 0; k < j; ++k)
-	attr_tab[i].attr[k] = attr_tab[i].attr_o[k] ^ XOR_CODE;
-      attr_tab[i].attr[j] = '\0';
-      attr_tab[i].alen = strlen(attr_tab[i].attr_o);
-      ++i;
-    }
-  first = S_FALSE;
-
+  int     j, k;
+
+  if (first == S_TRUE)
+    {
+      i = 0;
+      while (attr_tab[i].attr_o != NULL)
+	{
+	  j = strlen(attr_tab[i].attr_o);
+	  attr_tab[i].attr = malloc (j+1); /* only once */
+	  if (NULL == attr_tab[i].attr)
+	    SL_RETURN (NULL, _("sh_database_parse"));
+	  for (k = 0; k < j; ++k)
+	    attr_tab[i].attr[k] = attr_tab[i].attr_o[k] ^ XOR_CODE;
+	  attr_tab[i].attr[j] = '\0';
+	  ++i;
+	}
+      first = S_FALSE;
+    }
 #else
-
-  if (first == S_FALSE)
-    return;
-
-  i = 0;
-  while (attr_tab[i].attr_o != NULL)
-    {
-      attr_tab[i].attr = attr_tab[i].attr_o;
-      attr_tab[i].alen = strlen(attr_tab[i].attr_o);
-      ++i;
-    }
-  first = S_FALSE;
-
+  if (first == S_TRUE)
+    {
+      i = 0;
+      while (attr_tab[i].attr_o != NULL)
+	{
+	  attr_tab[i].attr = attr_tab[i].attr_o;
+	  ++i;
+	}
+      first = S_FALSE;
+    }
 #endif
-
-  /* create a sorted table for binary search
-   */
-  attr_tab_srch = SH_ALLOC(i * sizeof(my_attr));
-  for (j=0; j<i; ++j)
-    memcpy(&attr_tab_srch[j], &attr_tab[j], sizeof(my_attr));
-  qsort(attr_tab_srch, i, sizeof(my_attr), sh_database_comp_attr);
-  attr_tab_srch_siz = i;
-
   return;
 }
 
-int sh_database_add_to_hash  (const char * str)
+int sh_database_add_to_hash  (char * str)
 {
   int i;
@@ -1555,53 +1432,26 @@
 }
 
-static int is_escaped(char * p_in) {
+static int is_escaped(char * p) {
 
   int    escp = 0;
   int    retv = S_TRUE;
-  unsigned char * p = (unsigned char *) p_in;
-
-  if (*p != '\0')
-    {
-      do 
-	{
-	  if (*p <=  126 && *p >= 32)
-	    {
-	      if (escp == 0)
-		{
-		  if      (!((*p == '\'') || (*p == '\"') || (*p == '\\'))) 
-		    /* do nothing */;
-		  else if (*p == '\\') 
-		    {
-#ifndef WITH_MYSQL
-		      if (p[1] == '\'')
-			{
-			  *p = '\'';
-			}
-#endif
-		      escp = 1;
-		    }
-		  else  
-		    retv = S_FALSE; /* (*p == '\'' || *p == '\"') */
-		}
-	      else /* escp == 1 */
-		{
-		  escp = 0;
-		}
-	    }
-	  else /* *p > 126 || *p < 32 */
-	    {
-	      retv = S_FALSE;
-	    }
-	  
-	  ++p;
-	  
-	} 
-      while (*p != '\0');
-    }
-
-  if (escp == 0)
-    return retv;
-  else
-    return S_FALSE;
+
+  while (*p != '\0') 
+    {
+      if (*p == '\\')
+	{
+	  escp = (escp == 1) ? 0 : 1;
+	}
+      else if (*p == '\'' && escp == 0)
+	{
+	  retv = S_FALSE;
+	}
+      else 
+	{
+	  escp = 0;
+	}
+      ++p;
+    }
+  return retv;
 }
 
@@ -1619,7 +1469,4 @@
   int     i;
   size_t  j;
-  my_attr * res;
-  my_attr key;
-  char    key_str[64];
 
   SL_ENTER(_("sh_database_parse"));
@@ -1638,6 +1485,11 @@
     SL_RETURN (NULL, _("sh_database_parse"));
 
-  while ((*p != '\0') && (*p != '>'))
-    {
+  while ((p != NULL) && (*p != '\0') && (*p != '>'))
+    {
+      if (p[0] == '/' && p[1] == '>')
+	SL_RETURN (&p[2], _("sh_database_parse"));
+      if (p[0] == '/' && p[1] == 'l' && p[2] == 'o' && 
+	  p[3] == 'g' && p[4] == '>')
+	SL_RETURN (&p[5], _("sh_database_parse"));
       if (p[0] == 'l' && p[1] == 'o' && p[2] == 'g' &&
 	  (p[3] == ' ' || p[3] == '>'))
@@ -1646,9 +1498,4 @@
 	  goto parse;
 	}
-      else if (p[0] == '/' && p[1] == '>')
-	SL_RETURN (&p[2], _("sh_database_parse"));
-      else if (p[0] == '/' && p[1] == 'l' && p[2] == 'o' && 
-	  p[3] == 'g' && p[4] == '>')
-	SL_RETURN (&p[5], _("sh_database_parse"));
       ++p;
     }
@@ -1657,19 +1504,13 @@
  parse:
 
-  while (*p == ' ' || *p == '>')
+  while ((p != NULL) && (*p == ' ' || *p == '>'))
     ++p;
 
-  if (*p == '\0')
+  if (!p || *p == '\0')
     SL_RETURN(NULL, _("sh_database_parse"));
-
-  if (*p != '<' && *p != '/')
-    goto par2;
 
   if (p[0] == '<' && p[1] == 'l' &&
       p[2] == 'o' && p[3] == 'g')
     {
-      /* 
-       * recursive call 
-       */
       new       = SH_ALLOC(sizeof(dbins));
       init_db_entry(new);
@@ -1685,83 +1526,62 @@
     SL_RETURN (&p[5], _("sh_database_parse"));
 
- par2:
 
   /* non-whitespace 
    */
-  for (i=0; i < 64; ++i)
-    {
-      if (p[i] != '=')
-	{
-	  key_str[i] = p[i];
-	}
-      else
-	{
-	  key_str[i] = '\0';
-	  break;
-	}
-    }
-  key_str[63] = '\0';
-  key.attr = &key_str[0];
-
-  res = bsearch(&key, attr_tab_srch, attr_tab_srch_siz,
-		sizeof(my_attr), sh_database_comp_attr);
-
-  if (res != NULL)
-    {
-      j = res->alen; /* strlen(attr_tab[i].attr); */
-      if (p[j] == '=' && p[j+1] == '"')
+  i = 0;
+  while (attr_tab[i].attr != NULL)
+    {
+      j = strlen(attr_tab[i].attr);
+      if (0 == strncmp(p, attr_tab[i].attr, j) && 
+	  p[j] == '=' && p[j+1] == '"')
 	{
 	  q = strchr(&p[j+2], '"');
-	  if (q)
-	    {
-	      *q = '\0';
-
-	      if (S_TRUE == is_escaped(&p[j+2])) {
-
-		if      (res->val == 1)
-		  (void) sl_strlcpy(db_entry->sev, &p[j+2], 
-				    (size_t)res->size);
-		else if (res->val == 2)
-		  {
-		    z = strchr(&p[j+2], 'T');
-		    if (z) *z = ' ';
-		    (void) sl_strlcpy(db_entry->time, &p[j+2],  20);
-		  }
-		else if (res->val == 3)
-		  (void) sl_strlcpy(db_entry->host, &p[j+2], 
-				    (size_t) res->size);
-		else if (res->val == 4)
-		  (void) sl_strlcpy(db_entry->msg,  &p[j+2], 
-				    (size_t) res->size);
-		else if (res->size != 0)
-		  {
-		    (void) sl_strlcpy( (((char *)(db_entry))+ res->off),
-				       &p[j+2], 
-				       (size_t) res->size);
-		  }
-		else if (res->val >= START_SEC_LONGS && res->val <= END_SEC_LONGS)
-		  {
-		    db_entry->ulong_data[res->val-START_SEC_LONGS]
-		      = strtoul(&p[j+2], (char **) NULL, 0);
-		  }
-
-		*q = '"';
-		p  = q; 
-		++p;
-
-		goto parse;
-	      }
-	      else { /* S_FALSE == is_escaped(&p[j+2]) */
-		sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
-				_("Message not properly escaped"), 
-				_("sh_database_parse"));
-		SL_RETURN(NULL, _("sh_database_parse"));
-	      }
-	    }
-	  else /* q == NULL */
+	  if (!q)
 	    {
 	      SL_RETURN(NULL, _("sh_database_parse"));
 	    }
-	}
+	  else
+	    {
+	      *q = '\0';
+
+	      if (S_FALSE == is_escaped(&p[j+2])) {
+		SL_RETURN(NULL, _("sh_database_parse"));
+	      }
+
+	      if      (attr_tab[i].val == 1)
+		(void) sl_strlcpy(db_entry->sev, &p[j+2], 
+				  (size_t)attr_tab[i].size);
+	      else if (attr_tab[i].val == 2)
+		{
+		  z = strchr(&p[j+2], 'T');
+		  if (z) *z = ' ';
+		  (void) sl_strlcpy(db_entry->time, &p[j+2],  20);
+		}
+	      else if (attr_tab[i].val == 3)
+		(void) sl_strlcpy(db_entry->host, &p[j+2], 
+				  (size_t) attr_tab[i].size);
+	      else if (attr_tab[i].val == 4)
+		(void) sl_strlcpy(db_entry->msg,  &p[j+2], 
+				  (size_t) attr_tab[i].size);
+	      else if (attr_tab[i].size != 0)
+		{
+		  (void) sl_strlcpy( (((char *)(db_entry))+ attr_tab[i].off),
+				     &p[j+2], 
+				     (size_t) attr_tab[i].size);
+		}
+	      else if (attr_tab[i].val >= START_SEC_LONGS)
+		{
+		  db_entry->long_data[attr_tab[i].val-START_SEC_LONGS]
+		    = atol(&p[j+2]);
+		}
+
+	      *q = '"';
+	      p  = q; 
+	      ++p;
+
+	      goto parse;
+	    }
+	}
+      ++i;
     }
 
@@ -1776,58 +1596,18 @@
 static int enter_wrapper = 1;
 
-int set_enter_wrapper (const char * str)
+int set_enter_wrapper (char * str)
 {
   return sh_util_flagval(str, &enter_wrapper);
 }
 
-/* recursively enter linked list of messages into database, last first
- * - last is client (if this is a client message received by client)
- */
-long sh_database_insert_rec (dbins * curr, int depth, char * host)
-{
-  unsigned long    id = 0;
-
-  SL_ENTER(_("sh_database_insert_rec"));
-
-  if (curr->next)
-    {
-      /*
-      prev = curr->next;
-      sl_strlcpy(prev->host, curr->host, 64);
-      id = sh_database_insert_rec (curr->next, (depth + 1));
-      */
-      ++depth;
-      id = sh_database_insert_rec (curr->next, depth, curr->host);
-    }
-
-  if (host) 
-    sl_strlcpy(curr->host, host, 64);
-
-  if (id != 0)                       /* this is a server wrapper          */
-    {
-      if (enter_wrapper != 0)
-	{
-	  id = sh_database_entry (curr, id);
-	}
-    }
-  else
-    {
-      /*
-       * id = -1 is the client message; log_ref will be NULL 
-       */
-      if (depth > 0)                  /* this is a client message         */
-	id = sh_database_entry (curr, -1);
-      else                            /* this is a generic server message */
-	id = sh_database_entry (curr, 0);
-    }
-
-  SH_FREE(curr);
-
-  SL_RETURN(id, _("sh_database_insert_rec"));
-}
-
 int sh_database_insert (char * message)
 {
   dbins * db_entry;
+  dbins * prev;
+  dbins * curr;
+  long    id = 0;
+#ifdef HOST_SWITCH
+  char  * temp[64];
+#endif
 
   SL_ENTER(_("sh_database_insert"));
@@ -1840,7 +1620,32 @@
   (void) sh_database_parse (message, db_entry);
 
-  /* recursively enter the linked list into the database
-   */
-  (void) sh_database_insert_rec (db_entry, 0, NULL);
+  /* Enter the list into the database. Actually, the list can only have
+   * two entries at most.
+   */
+  curr = db_entry;
+  if (curr->next)
+    {
+      prev = curr->next;
+#ifdef HOST_SWITCH
+      strncpy(temp, prev->host,       64);
+#endif
+      strncpy(prev->host, curr->host, 64);
+#ifdef HOST_SWITCH
+      strncpy(curr->host, temp,       64);
+#endif
+      id = sh_database_entry (prev, -1);
+      SH_FREE(prev);
+    }
+
+  if (id != 0)                       /* this is a server wrapper          */
+    {
+      if (enter_wrapper != 0)
+	(void) sh_database_entry (curr, id);
+    }
+  else                                /* this is a generic server message */
+    {
+      (void) sh_database_entry (curr, 0);
+    }
+  SH_FREE(curr);
 
   SL_RETURN(0, _("sh_database_insert"));
Index: /trunk/src/sh_entropy.c
===================================================================
--- /trunk/src/sh_entropy.c	(revision 584)
+++ /trunk/src/sh_entropy.c	(revision 1)
@@ -30,8 +30,15 @@
 #endif
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
+#endif
+#endif
+
 
 #include <stdlib.h>
@@ -110,5 +117,5 @@
 int sh_entropy(int getbytes, char * nbuf)
 {
-    int fd = -1;
+    static int fd = -1;
     int n;
     byte buffer[256+2];
@@ -131,5 +138,5 @@
     if( do_restart ) {
         if( fd != -1 ) {
-            sl_close_fd(FIL__, __LINE__,  fd );
+            close( fd );
             fd = -1;
         }
@@ -140,9 +147,8 @@
         struct sockaddr_un addr;
         int addr_len;
-	int retval;
-
-#ifdef EGD_SOCKET_NAME
+
+      #ifdef EGD_SOCKET_NAME
         bname = EGD_SOCKET_NAME;
-#endif
+      #endif
         if ( !bname || !*bname )
             bname = _("=entropy");
@@ -164,5 +170,5 @@
         memset( &addr, 0, sizeof(addr) );
         addr.sun_family = AF_UNIX;
-        sl_strlcpy( addr.sun_path, name, sizeof(addr.sun_path) );
+        strcpy( addr.sun_path, name );              /* known to fit  */
         addr_len = offsetof( struct sockaddr_un, sun_path )
                    + strlen( addr.sun_path );
@@ -178,8 +184,5 @@
 	    SL_RETURN( -1, _("sh_entropy") );
 	  }
-	do {
-	  retval = connect(fd, (struct sockaddr *) &sinr, sizeof(sinr));
-	} while (retval < 0 && (errno == EINTR || errno == EINPROGRESS));
-        if( retval == -1 )
+        if( connect( fd, (struct sockaddr*)&addr, addr_len) == -1 )
 	  {
 	    myerror = errno;
@@ -188,5 +191,4 @@
 			     _("sh_entropy") ); 
 	    SH_FREE(name);
-	    sl_close_fd(FIL__, __LINE__, fd);
 	    SL_RETURN( -1, _("sh_entropy") );
 	  }
@@ -204,6 +206,5 @@
 	    sh_error_handle ((-1), FIL__, __LINE__, myerror, MSG_E_SUBGEN,
 			     _("cannot write to EGD"),
-			     _("sh_entropy") );
-	    sl_close_fd(FIL__, __LINE__, fd);
+			     _("sh_entropy") ); 
 	    SL_RETURN( -1, _("sh_entropy") );
 	  }
@@ -246,6 +247,5 @@
 	    sh_error_handle ((-1), FIL__, __LINE__, myerror, MSG_E_SUBGEN,
 			     _("cannot write to EGD"),
-			     _("sh_entropy") );
-	    sl_close_fd(FIL__, __LINE__, fd);
+			     _("sh_entropy") ); 
 	    SL_RETURN( -1, _("sh_entropy") );
 	  }
@@ -267,5 +267,5 @@
     }
     memset(buffer, 0, sizeof(buffer) );
-    sl_close_fd(FIL__, __LINE__, fd);
+
     SL_RETURN( 0, _("sh_entropy") ); /* success */
 }
@@ -276,11 +276,33 @@
 #if defined (HAVE_URANDOM)
 
-#include "sh_pthread.h"
-
-int read_mbytes(int timeout_val, const char * path, char * nbuf, int nbytes)
+#include <setjmp.h>
+
+static jmp_buf          entropy_timeout;
+
+static void sh_entropy_alarmhandle (int mysignal)
 {
-  int m_count;
+  (void) mysignal; /* avoid compiler warning */
+  longjmp (entropy_timeout, 1);
+}
+
+
+int read_mbytes(int timeout_val, char * path, char * nbuf, int nbytes)
+{
+  int count, m_count;
   int fd2;
 
+  struct  sigaction  new_act;
+  sigset_t           unblock;
+
+  struct sigaction      old_act;
+  volatile unsigned int old_alarm = 0;
+
+  new_act.sa_handler = sh_entropy_alarmhandle;
+  sigemptyset( &new_act.sa_mask );       /* set an empty mask       */
+  new_act.sa_flags = 0;                  /* init sa_flags           */
+
+  sigemptyset(&unblock);
+  sigaddset  (&unblock, SIGALRM);
+
   SL_ENTER(_("read_mbytes"));
 
@@ -288,12 +310,59 @@
     {
       /* Test whether file is a character device, and is 
-       * readable.
-       */
-      if (0 == sh_unix_device_readable(fd2)) 
+       * not world writeable.
+       */
+      if (0 == sh_unix_file_exists(fd2)) 
 	{
-	  m_count = sl_read_timeout_fd(fd2, nbuf, nbytes, 
-				       timeout_val, S_FALSE);
-	  if (m_count < 0)
-	    m_count = 0;
+
+	  /* alarm was triggered
+	   */
+	  if (setjmp(entropy_timeout) != 0)
+	    {
+	      alarm(0);
+	      sigaction (SIGALRM, &old_act, NULL);
+	      alarm(old_alarm);
+	      sigprocmask(SIG_UNBLOCK, &unblock, NULL);
+	      TPT((0,FIL__,__LINE__, _("msg=<read_mbytes: timeout>\n"))); 
+	      close (fd2);
+	      SL_RETURN(0, _("read_mbytes"));
+	    }
+
+	  /* timeout after 30 seconds
+	   */
+	  old_alarm = alarm(0);
+	  sigaction (SIGALRM, &new_act, &old_act);
+	  alarm(timeout_val);
+
+	  m_count = 0;
+
+	  while (m_count < nbytes) 
+	    {
+	      errno = 0; /* paranoia */
+	      count = read (fd2, &nbuf[m_count], nbytes-m_count);
+
+	      switch (count)
+		{
+		case -1:
+#ifdef EWOULDBLOCK
+                  if (errno == EINTR || errno == EAGAIN ||
+                      errno == EWOULDBLOCK)
+#else
+                  if (errno == EINTR || errno == EAGAIN)
+#endif
+                    continue;
+
+                  /* if errno == -1 && no continue: fallthrough to this */
+                case 0:
+                  break;
+                default:
+                  m_count += count;
+                }
+	    }
+	  close (fd2);
+
+	  alarm(0);
+	  sigaction (SIGALRM, &old_act, NULL);
+	  alarm(old_alarm);
+	  sigprocmask(SIG_UNBLOCK, &unblock, NULL);
 	}
       else
@@ -302,6 +371,4 @@
   else
     m_count = 0;
-
-  sl_close_fd(FIL__, __LINE__, fd2);
 
   TPT((0, FIL__, __LINE__, _("msg=<read_mbytes: OK>\n"))); 
@@ -317,5 +384,4 @@
   int    i, m_count = 0;
   char * keybuf;
-  UINT32 kbuf[KEY_BYT/sizeof(UINT32)];
   char   addbuf[2 * KEY_BYT];
 
@@ -327,10 +393,10 @@
     nbytes = KEY_BYT;
 
-  memset(nbuf, 0, nbytes);
+  memset(nbuf, '\0', nbytes);
 
 #ifdef NAME_OF_DEV_URANDOM
-  m_count = read_mbytes ( 10, NAME_OF_DEV_URANDOM, nbuf, nbytes);
+  m_count = read_mbytes (30, NAME_OF_DEV_RANDOM, nbuf, nbytes);
 #else
-  m_count = read_mbytes (300, NAME_OF_DEV_RANDOM,  nbuf, nbytes);
+  m_count = read_mbytes (300, NAME_OF_DEV_RANDOM, nbuf, nbytes);
 #endif
 
@@ -339,5 +405,5 @@
 #ifdef NAME_OF_DEV_URANDOM
       sh_error_handle (SH_ERR_NOTICE, FIL__, __LINE__, EIO, MSG_NODEV, 
-		       (long) sh.real.uid, NAME_OF_DEV_URANDOM);
+		       (long) sh.real.uid, NAME_OF_DEV_RANDOM);
 #else
       sh_error_handle ((-1), FIL__, __LINE__, EIO, MSG_NODEV, 
@@ -346,11 +412,11 @@
     }
 
-#ifdef NAME_OF_DEV_RANDOM
+#ifdef NAME_OF_DEV_URANDOM
   if (m_count < nbytes)
     {
-      i = read_mbytes(300, NAME_OF_DEV_RANDOM, &nbuf[m_count], nbytes-m_count);
+      i = read_mbytes(30, NAME_OF_DEV_URANDOM, &nbuf[m_count], nbytes-m_count);
       if (i == 0)
 	sh_error_handle ((-1), FIL__, __LINE__, EIO, MSG_NODEV, 
-			 (long) sh.real.uid, NAME_OF_DEV_RANDOM);
+			 (long) sh.real.uid, NAME_OF_DEV_URANDOM);
       else
 	m_count += i;
@@ -363,5 +429,5 @@
       /* -- Add previous entropy into the new pool. --
        */
-      memset(addbuf, 0, sizeof(addbuf));
+      memset(addbuf, '\0', sizeof(addbuf));
       for (i = 0; i < m_count; ++i)
 	addbuf[i]         = nbuf[i];
@@ -369,11 +435,9 @@
 	addbuf[i+KEY_BYT] = skey->poolv[i];
       keybuf = (char *) sh_tiger_hash_uint32 (addbuf, 
-					      TIGER_DATA, 2 * KEY_BYT,
-					      kbuf, KEY_BYT/sizeof(UINT32));
-      memset(addbuf, 0, sizeof(addbuf));
+					      TIGER_DATA, 2 * KEY_BYT);
+      memset(addbuf, '\0', sizeof(addbuf));
       
       /* -- Give out nbytes bytes from the new pool. --
        */
-      SH_MUTEX_LOCK_UNSAFE(mutex_skey);
       for (i = 0; i < KEY_BYT; ++i)
 	{
@@ -382,7 +446,5 @@
 	    nbuf[i] = keybuf[i];
 	}
-      SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-      memset (keybuf, 0, KEY_BYT);
-      memset (kbuf,   0, sizeof(kbuf));
+      memset (keybuf, '\0', KEY_BYT);
       
       SL_RETURN(0, _("sh_entropy"));
@@ -409,13 +471,11 @@
 #endif
 #ifndef FD_ZERO
-#define FD_ZERO(p)      memset((char *)(p), 0, sizeof(*(p)))
+#define FD_ZERO(p)      memset((char *)(p), '\0', sizeof(*(p)))
 #endif
 
 #include "sh_static.h"
-#include "sh_pthread.h"
 
 static
 char   * com_path[] = {
-  N_("/usr/bin/xpg4/"),
   N_("/usr/ucb/"),
   N_("/bin/"),
@@ -424,5 +484,4 @@
   N_("/usr/sbin/"),
   N_("/usr/local/bin/"),
-  N_("/opt/local/bin/"),
   NULL
 };
@@ -439,5 +498,5 @@
 
 static
-sourcetable_t source_template[] = {
+sourcetable_t source[] = {
   { N_("w"),
     N_("w"),
@@ -508,31 +567,12 @@
   int pipedes[2];
   FILE *outf = NULL;
+  struct passwd * tempres;
   char * arg[4];
   char * envp[2];
-  size_t len;
-  char   arg0[80];
-  char   arg1[80];
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  struct passwd    pwd;
-  char           * buffer;
-  struct passwd *  tempres;
-#else
-  struct passwd * tempres;
-#endif
 
   SL_ENTER(_("sh_popen"));
 
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  buffer = SH_ALLOC(SH_PWBUF_SIZE);
-  sh_getpwnam_r(DEFAULT_IDENT, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
-  tempres = sh_getpwnam(DEFAULT_IDENT);
-#endif
-
-  strncpy (arg0, _("/bin/sh"), sizeof(arg0));
-  arg[0] = arg0;
-  strncpy (arg1, _("-c"), sizeof(arg1));
-  arg[1] = arg1;
+  arg[0] = _("/bin/sh");
+  arg[1] = _("-c");
   arg[2] = command;
   arg[3] = NULL;
@@ -540,8 +580,7 @@
   if (sh.timezone != NULL)
     {
-      len = sl_strlen(sh.timezone) + 4;
-      envp[0] = calloc(1, len);     /* free() ok     */
+      envp[0] = malloc (sl_strlen(sh.timezone) + 4);     /* free() ok     */
       if (envp[0] != NULL)
-	sl_snprintf (envp[0], len, "TZ=%s", sh.timezone);
+	sprintf (envp[0], "TZ=%s", sh.timezone);         /* known to fit  */
       else
 	envp[0] = NULL;
@@ -561,6 +600,4 @@
   }
   
-  fflush (NULL);
-
   source->pid = aud_fork(FIL__, __LINE__);
   
@@ -568,6 +605,6 @@
    */
   if (source->pid == (pid_t) - 1) {
-    sl_close_fd(FIL__, __LINE__, pipedes[0]);
-    sl_close_fd(FIL__, __LINE__, pipedes[1]);
+    close(pipedes[0]);
+    close(pipedes[1]);
     if (envp[0] != NULL) free(envp[0]);
     SL_RETURN(NULL, _("sh_popen"));
@@ -576,23 +613,19 @@
   if (source->pid == (pid_t) 0) 
     {
-      int val_return;
 
       /* child - make read side of the pipe stdout 
        */
-      do {
-	val_return = dup2 (pipedes[STDOUT_FILENO], STDOUT_FILENO);
-      } while (val_return < 0 && errno == EINTR);
-
-      if (val_return < 0)
-	_exit(EXIT_FAILURE);
+      if (retry_aud_dup2(FIL__, __LINE__, 
+			 pipedes[STDOUT_FILENO], STDOUT_FILENO) < 0)
+	aud__exit(FIL__, __LINE__, EXIT_FAILURE);
       
       /* close the pipe descriptors 
        */
-      sl_close_fd   (FIL__, __LINE__, pipedes[STDIN_FILENO]);
-      sl_close_fd   (FIL__, __LINE__, pipedes[STDOUT_FILENO]);
+      close   (pipedes[STDIN_FILENO]);
+      close   (pipedes[STDOUT_FILENO]);
 
       /* don't leak file descriptors
        */
-      sh_unix_closeall (3, -1, S_TRUE); /* in child process */
+      sh_unix_closeall (3, -1); /* in child process */
 
       /* zero priv info
@@ -603,73 +636,57 @@
        */
       i = 0; 
-      if (0 == geteuid()) 
-	{
-  
-	  if (NULL != tempres) {
-	    i = setgid(tempres->pw_gid);
-
-	    /*** locks up in dnmalloc ***/
-	    /*
-	     * if (i == 0)
-	     *   i = sh_unix_initgroups(DEFAULT_IDENT ,tempres->pw_gid);
-	     */
-
-	    if (i == 0) 
-	      i = setuid(tempres->pw_uid);
-	    /* make sure we cannot get root again
-	     */
-	    if ((tempres->pw_uid != 0) && 
-		(setuid(0) >= 0))
-	      i = -1;
-	  } else {
+      if (0 == geteuid()) {  
+	tempres = sh_getpwnam(DEFAULT_IDENT);
+	if (NULL != tempres) {
+	  i = aud_setgid(FIL__, __LINE__, tempres->pw_gid); 
+	  if (i == 0)
+	    i = sh_unix_initgroups(DEFAULT_IDENT ,tempres->pw_gid);
+	  if (i == 0) 
+	    i = aud_setuid(FIL__, __LINE__, tempres->pw_uid);
+	  /* make sure we cannot get root again
+	   */
+	  if ((tempres->pw_uid != 0) && (aud_setuid(FIL__, __LINE__, 0) >= 0))
 	    i = -1;
-	  }
+	} else {
+	  i = -1;
 	}
+      }
       
       /* some problem ...
        */
       if (i == -1) {
-	_exit(EXIT_FAILURE);
+	aud__exit(FIL__, __LINE__, EXIT_FAILURE);
       }
       
-      /* cppcheck-suppress leakNoVarFunctionCall */
-      if (NULL != freopen (_("/dev/null"), "r+", stderr))
-	{
+      freopen (_("/dev/null"), "r+", stderr);
       
-	  /* exec the program */
-	  do {
-	    val_return = execve (_("/bin/sh"), arg, envp);
-	  } while (val_return < 0 && errno == EINTR);
-	}
-
+      /* exec the program */
+      retry_aud_execve (FIL__, __LINE__, _("/bin/sh"), arg, envp);
+      
       /* failed 
        */
-      _exit(EXIT_FAILURE);
-    }
-
-  /* parent
-   */
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-  SH_FREE(buffer);
-#endif
-
-  if (envp[0] != NULL) 
-    free(envp[0]);
-  
-  sl_close_fd (FIL__, __LINE__, pipedes[STDOUT_FILENO]);
-  retry_fcntl (FIL__, __LINE__, pipedes[STDIN_FILENO], F_SETFD, FD_CLOEXEC);
-  
-  outf = fdopen (pipedes[STDIN_FILENO], "r");
-  
-  if (outf == NULL) 
-    {
-      aud_kill (FIL__, __LINE__, source->pid, SIGKILL);
-      sl_close_fd (FIL__, __LINE__, pipedes[STDOUT_FILENO]);
-      waitpid (source->pid, NULL, 0);
-      source->pid = 0;
-      SL_RETURN(NULL, _("sh_popen"));
-    }
-  
-  SL_RETURN(outf, _("sh_popen"));
+      aud__exit(FIL__, __LINE__, EXIT_FAILURE);
+    }
+
+    /* parent
+     */
+    if (envp[0] != NULL) 
+      free(envp[0]);
+
+    close (pipedes[STDOUT_FILENO]);
+    retry_fcntl (FIL__, __LINE__, pipedes[STDIN_FILENO], F_SETFD, FD_CLOEXEC);
+
+    outf = fdopen (pipedes[STDIN_FILENO], "r");
+
+    if (outf == NULL) 
+      {
+        aud_kill (FIL__, __LINE__, source->pid, SIGKILL);
+	close (pipedes[STDOUT_FILENO]);
+        waitpid (source->pid, NULL, 0);
+        source->pid = 0;
+	SL_RETURN(NULL, _("sh_popen"));
+      }
+
+    SL_RETURN(outf, _("sh_popen"));
 }
 
@@ -678,42 +695,15 @@
 {
     int status = 0;
-    int retval;
-    char msg[128];
-    char errbuf[SH_ERRBUF_SIZE];
 
     SL_ENTER(_("sh_pclose"));
 
-    retval = sl_fclose(FIL__, __LINE__, source->pipe);
-    if (retval)
+    status = fclose(source->pipe);
+    if (status)
       {
-	sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, retval, 
-			 MSG_E_SUBGEN,
-			 sh_error_message(retval, errbuf, sizeof(errbuf)),
-                         _("sh_pclose"));
 	SL_RETURN((-1), _("sh_pclose"));
       }
 
-    retval = waitpid(source->pid, &status, 0);
-    if (retval != source->pid)
-      {
-	sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, retval, 
-			 MSG_E_SUBGEN,
-			 sh_error_message(retval, errbuf, sizeof(errbuf)),
-                         _("sh_pclose"));
-
-	status = -1;
-      }
-#if !defined(USE_UNO)
-    else if (WIFSIGNALED(status))
-      {
-	sl_snprintf(msg, sizeof(msg), _("Subprocess terminated by signal %d"),
-		    WTERMSIG(status));
-	sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, retval, 
-			 MSG_E_SUBGEN,
-			 msg,
-                         _("sh_pclose"));
-	status = -1;
-      }
-#endif
+    if (waitpid(source->pid, NULL, 0) != source->pid)
+      status = -1;
 
     source->pipe = NULL;
@@ -738,5 +728,4 @@
 
   char * keybuf;
-  UINT32 kbuf[KEY_BYT/sizeof(UINT32)];
   char   addbuf[2 * KEY_BYT];
 
@@ -746,8 +735,5 @@
   int    maxFD = 0;
   int    imax, selcount;
-  char errbuf[SH_ERRBUF_SIZE];
-
-  sourcetable_t  *source = NULL;
-  
+
   SL_ENTER(_("sh_entropy"));
 
@@ -760,5 +746,4 @@
   /* --- If there is entropy in the pool, return it. ---
    */
-  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
   if (skey->poolc >= nbytes)
     {
@@ -769,8 +754,6 @@
 	  --skey->poolc;
 	}
-      SH_MUTEX_UNLOCK_UNSAFE(mutex_skey); /* alternative path */
       SL_RETURN(0, _("sh_entropy"));
     }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
 
 
@@ -783,17 +766,9 @@
     {
       sh_error_handle((-1), FIL__, __LINE__, caperr, MSG_E_SUBGEN,
-		      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
+		      sh_error_message (caperr), 
 		      _("sl_get_cap_sub"));
     }
 
-  while (source_template[i].command != NULL) {
-    ++i;
-  }
-  source = SH_ALLOC(i * sizeof(sourcetable_t));
-  for (j = 0; j < i;++j)
-    memcpy(&source[j], &source_template[j], sizeof(sourcetable_t));
-  i = 0;
-
-  while (source_template[i].command != NULL) {
+  while (source[i].command != NULL) {
 
     j = 0;
@@ -803,5 +778,4 @@
 	sl_strlcat(combuf, _(source[i].command), 80);
 
-	/* flawfinder: ignore */
 	if ( access (combuf, X_OK) == 0) 
 	  {
@@ -925,47 +899,20 @@
     }
   buffer[bufcount] = '\0';
-  
-  SH_FREE(source);
 
   if (0 != (caperr = sl_drop_cap_sub()))
     {
       sh_error_handle((-1), FIL__, __LINE__, caperr, MSG_E_SUBGEN,
-		      sh_error_message (caperr, errbuf, sizeof(errbuf)), 
+		      sh_error_message (caperr), 
 		      _("sl_drop_cap_sub"));
     }
 
-#ifdef HAVE_GETTIMEOFDAY
-  {
-    unsigned short tseed[3];
-
-    gettimeofday(&tv, 0);
-    tseed[0] = tv.tv_sec & 0xFFFF;
-    tseed[1] = tv.tv_usec & 0xFFFF;
-    tseed[2] = (tv.tv_sec ^ tv.tv_usec) >> 16;
-    keybuf = (char *) sh_tiger_hash_uint32 ((char *) tseed, 
-					    TIGER_DATA, sizeof(tseed),
-					    kbuf, KEY_BYT/sizeof(UINT32));
-    memset(addbuf, 0, sizeof(addbuf));
-    for (i = 0; i < KEY_BYT; ++i)
-      {
-	addbuf[i]         = keybuf[i];
-	addbuf[i+KEY_BYT] = skey->poolv[i];
-      }
-    SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-    for (i = 0; i < KEY_BYT; ++i)
-      skey->poolv[i] ^= keybuf[i];
-    SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-  }
-#endif
-
   if (bufcount > 0) 
     {
       keybuf = (char *) sh_tiger_hash_uint32 (buffer, 
-					      TIGER_DATA, sl_strlen(buffer),
-					      kbuf, KEY_BYT/sizeof(UINT32));
+					      TIGER_DATA, sl_strlen(buffer));
 
       /* add previous entropy into the new pool
        */
-      memset(addbuf, 0, sizeof(addbuf));
+      memset(addbuf, '\0', sizeof(addbuf));
       for (i = 0; i < KEY_BYT; ++i)
 	{
@@ -974,17 +921,14 @@
 	}
       keybuf = (char *) sh_tiger_hash_uint32 (addbuf, 
-					      TIGER_DATA, sizeof(addbuf),
-					      kbuf, KEY_BYT/sizeof(UINT32));
-      memset(addbuf, 0, sizeof(addbuf));
+					      TIGER_DATA, sizeof(addbuf));
+      memset(addbuf, '\0', sizeof(addbuf));
       
       /* store in system pool
        */
-      SH_MUTEX_LOCK_UNSAFE(mutex_skey);
       for (i = 0; i < KEY_BYT; ++i)
 	skey->poolv[i] = keybuf[i];
       skey->poolc = KEY_BYT;
-      SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-      memset (buffer, 0, BUF_ENT+2);
-      memset (keybuf, 0, KEY_BYT);
+      memset (buffer, '\0', BUF_ENT+2);
+      memset (keybuf, '\0', KEY_BYT);
       SH_FREE(buffer);
     } 
@@ -997,5 +941,4 @@
   /* give out nbytes Bytes from the entropy pool
    */
-  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
   for (i = 0; i < nbytes; ++i)
     {
@@ -1003,5 +946,4 @@
       --skey->poolc;
     }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
 
   SL_RETURN(0, _("sh_entropy"));
@@ -1011,38 +953,8 @@
 #endif
 
-#ifdef SH_CUTEST
-#include "CuTest.h"
-
-void Test_entropy (CuTest *tc)
-{
-  char                 bufx[9 * sizeof(UINT32) + 1];
-  char                 bufy[9 * sizeof(UINT32) + 1];
-  int                  status;
-  int                  count;
-
-  for (count = 0; count < 20; ++count)
-    {
-      memset(skey->poolv, 0, KEY_BYT);
-      skey->poolc = 0;
-
-      status = sh_entropy (24, bufx);
-      CuAssertTrue(tc, 0 == status);
-      
-      memset(skey->poolv, 0, KEY_BYT);
-      skey->poolc = 0;
-
-      status = sh_entropy (24, bufy);
-      CuAssertTrue(tc, 0 == status);
-      
-      CuAssertTrue(tc, 0 != memcmp(bufx, bufy, 24));
-    }
-}
-#endif
-
-
-
-
-
-
-
-
+
+
+
+
+
+
